# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class Charge(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        Charge - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'amount': 'int',
            'date': 'str',
            'holder_name': 'str',
            'type': 'str'
        }

        self.attribute_map = {
            'amount': 'amount',
            'date': 'date',
            'holder_name': 'holder_name',
            'type': 'type'
        }

        self._amount = None
        self._date = None
        self._holder_name = None
        self._type = None

    @property
    def amount(self):
        """
        Gets the amount of this Charge.
        Amount of charges

        :return: The amount of this Charge.
        :rtype: int
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """
        Sets the amount of this Charge.
        Amount of charges

        :param amount: The amount of this Charge.
        :type: int
        """
        self._amount = amount

    @property
    def date(self):
        """
        Gets the date of this Charge.
        Date of charge

        :return: The date of this Charge.
        :rtype: str
        """
        return self._date

    @date.setter
    def date(self, date):
        """
        Sets the date of this Charge.
        Date of charge

        :param date: The date of this Charge.
        :type: str
        """
        self._date = date

    @property
    def holder_name(self):
        """
        Gets the holder_name of this Charge.
        Holder of the charge

        :return: The holder_name of this Charge.
        :rtype: str
        """
        return self._holder_name

    @holder_name.setter
    def holder_name(self, holder_name):
        """
        Sets the holder_name of this Charge.
        Holder of the charge

        :param holder_name: The holder_name of this Charge.
        :type: str
        """
        self._holder_name = holder_name

    @property
    def type(self):
        """
        Gets the type of this Charge.
        Charge type - creation, modification etc

        :return: The type of this Charge.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this Charge.
        Charge type - creation, modification etc

        :param type: The type of this Charge.
        :type: str
        """
        allowed_values = ["Creation", "Modification"]
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type`, must be one of {0}"
                .format(allowed_values)
            )
        self._type = type

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

